unit Main;

interface

uses
  Graphics, Controls, Forms, StdCtrls, ExtCtrls,
  Classes,
  IdBaseComponent, IdComponent, IdTCPServer, IdContext, IdCommandHandlers,
  SysUtils, IdCmdTCPServer,LResources,IdGlobal;

type
  TformMain = class(TForm)
    IdCmdTCPServer1: TIdCmdTCPServer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IdCmdTCPServer1Connect(AContext: TIdContext);
    procedure IdCmdTCPServer1cmdhQuitCommand(ASender: TIdCommand);
    procedure IdCmdTCPServer1cmdhLookupCommand(ASender: TIdCommand);
  private
  protected
    FZipCodeList: TStrings;
  public
  end;

  TUserData = class
  public
    FRequestCount: Integer;
  end;

var
  formMain: TformMain;

implementation


uses
  SyncObjs;

procedure TformMain.FormCreate(Sender: TObject);
begin
  IdCmdTCPServer1.Bindings[0].SetPeer('127.0.0.1',6000,id_ipv4);
  FZipCodeList := TStringList.Create;
  FZipCodeList.LoadFromFile(includetrailingpathdelimiter(ExtractFilePath(Application.EXEName))
   + includetrailingpathdelimiter('..')+ 'ZipCodes.dat');
end;

procedure TformMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FZipCodeList);
end;

procedure TformMain.IdCmdTCPServer1Connect(AContext: TIdContext);
begin
  AContext.Data := TUserData.Create;
end;

procedure TformMain.IdCmdTCPServer1cmdhQuitCommand(ASender: TIdCommand);
begin
  ASender.Reply.Text.Add(IntToStr(TUserData(ASender.Context.Data).FRequestCount)
   + ' requests processed.');
end;

procedure TformMain.IdCmdTCPServer1cmdhLookupCommand(ASender: TIdCommand);
var
  i: integer;
  LCity: string;
  LPostCode: string;
begin
  LPostCode := '';
  if ASender.Params.Count > 0 then begin
    for i := 0 to ASender.Params.Count - 1 do begin
      LPostCode := ASender.Params[i];
      LCity := FZipCodeList.Values[LPostCode];
      if LCity <> '' then begin
        Inc(TUserData(ASender.Context.Data).FRequestCount);
        ASender.Response.Add(LPostCode + ': ' + LCity);
      end;
    end;
  end;
end;

initialization
 {$i main.lrs}
end.


